<?php defined( '_VALID_MOS' ) or die( 'Restricted access' ); 

class HtmlCategoryList{
	private $viewAmountTotalLinks;
	private $viewAmountTotalSubCategories;
	private $viewCategoryDescription;
	private $viewCategoryImage;
	
	private $amountColumn;
	private $Itemid;
	private $delimiter;
	
	private $htmlColumnCounter = 0;
	
 	final function __construct($ItemId,$amountColumn=2,$delimiter=' ', $viewAmountTotalLinks=0,$viewAmountTotalSubCategories=0, $viewCategoryDescription,$viewCategoryImage) {
    	$this->Itemid = $ItemId;
 		$this->amountColumn = $amountColumn;
		$this->delimiter = $delimiter;
 		$this->viewAmountTotalLinks = $viewAmountTotalLinks;
   		$this->viewAmountTotalSubCategories = $viewAmountTotalSubCategories;
   		$this->viewCategoryDescription = $viewCategoryDescription;
   		$this->viewCategoryImage = $viewCategoryImage; 
   	}

	private final function showCategorieImage($view,$imageFileName,$imageAlt){
		global $mosConfig_live_site;
		if (($view) && ($imageFileName)) {
			?>
	<img
		src="<?php echo $mosConfig_live_site ;?>/images/stories/<?php echo $imageFileName;?>"
		border="0" alt="<?php echo $imageAlt ;?>" />
	<br />
			<?php }
	}
	
	private final function showCategorieDescr($description){
		if (($this->viewCategoryDescription) && ($description)) {
			echo '<br />'.stripslashes($description);
		}
	}
	
	private final function isLinksOrSubCategoriesAvailable(&$row){
		$a= TotalLink($row->id);
		$b= TotalSubCat($row->id);
		return (TotalLink($row->id) + TotalSubCat($row->id) > 0);
	}
	
	private final function getTextWithDelimiter(&$text){
		switch ($this->delimiter) {
			case '[':
				return '['.$text.']';
			case '(':
				return '('.$text.')';
			case '{':
				return '{'.$text.'}';
			case 'lt':
				return '&lt;'.$text.'&gt;';
			case '[ ':
				return '['.$text.']'. ' ';
			case '( ':
				return '('.$text.')'. ' ';
			case '{ ':
				return '{'.$text.'}'. ' ';
			case 'lt ':
				return '&lt;'.$text.'&gt;'. ' ';				
			case '':
				return $text;
			case ' ': 
			default:	
				return $text . ' ';
		}
	}
	
	/**
	 * Einspaltige und einzeilige Anzeige der Kategorien
	 *
	 * @param $rows_of_category Kategorien, die angezeigt werden sollen
	 */
	public final function displayInOneColumnMode(&$rows_of_category){
		?>
		<tr>
				<td width="100%" valign="top" class="mainCat">
				<?php
				foreach ($rows_of_category as $row) {
					$link = sefRelToAbs(getCatURL('viewcat',$row->id,$this->Itemid));
					if ($this->isLinksOrSubCategoriesAvailable($row)) { 
					?>
<a href="<?php echo $link;?>"><span class="ld_mainCat"><?php echo $this->getTextWithDelimiter($row->name);?></span></a><?php
					} else {
					?>
<span class="ld_mainCatNonLink"><?php echo $this->getTextWithDelimiter($row->name);?></span><?php
					}
				}
				?>
				</td>
			</tr>	
		<?php
	}
	
	
	
	public final function displayInMultiColumnMode(&$rows_of_category){
		$bol = intval(100 / $this->amountColumn);
		for ($i=0, $n=count( $rows_of_category ); $i < $n; $i++) {
			$this->displayRowBegin();
				$row = &$rows_of_category[$i];
				$totalLinkAndSubCat=showTotalLinkAndSubCat($row->id,$this->viewAmountTotalLinks,$this->viewAmountTotalSubCategories);
				?>
				<td width="<?php echo $bol;?>%" valign="top" align="center">
					<?php $this->displayCategoryItem($row); ?>
				</td>
				<?php
			$this->displayRowEnd();
		}
	}
	
	private final function displayCategoryItem(&$row){
		$link = sefRelToAbs(getCatURL('viewcat',$row->id,$this->Itemid));
		$this->showCategorieImage($this->viewCategoryImage,$row->image,$row->name);
		if ($this->isLinksOrSubCategoriesAvailable($row)){
		?> <a 
			href="<?php echo $link;?>"><span class="ld_mainCat"><?php echo $row->name;?></span></a>&nbsp;<?php
		} else {
			?><span class="ld_mainCatNonLink"><?php echo $row->name;?></span>&nbsp;<?php
		}		
		echo $totalLinkAndSubCat ?>	
			<?php $this->showCategorieDescr($row->description);
			?> <br />
			<?php SubCategories($row->id); ?><br />
			<br />
			<?php
	}
		
		
	private final function displayRowBegin(){
			if ($this->htmlColumnCounter==0) { ?>
			<tr>
			<?php 
		}
	}
	
	private final function displayRowEnd(){
			$this->htmlColumnCounter++;
			if ($this->amountColumn == $this->htmlColumnCounter) {?>
				</tr><?php
				$this->htmlColumnCounter = 0;
			}
	}
}	

if (count($this->rows_of_category)) {
	$html = new HtmlCategoryList($this->Itemid,$this->column,$this->categoryDelimiter,$this->tlink,$this->tslink,$this->catdesc,$this->catimage);
	?>
<table width="100%" border="0">
<?php
	if ($this->column == 1){
		$html->displayInOneColumnMode($this->rows_of_category);
	} else {
		$html->displayInMultiColumnMode($this->rows_of_category);			
	}
?>
</table>
<?php
}
?>
